extends layout
block content
	#map
	script(type='text/javascript').
		var token = 'pk.eyJ1IjoidGFrZXRoZWZha2UiLCJhIjoiY2luazQycXp3MDA3Y3Zza2wwY3I3dWltMCJ9.qB6xcZC4dJTVqo6q5Qt4NQ';
		L.mapbox.accessToken = token;
		L.MakiMarkers.accessToken = token;
		var map = L.mapbox.map('map', 'mapbox.streets').setView([#{lat}, #{lng}], 15);
		var visitorLayers = [];
		var stationLayers= [];
		var clusterLayer=[];
		var stationGroup = L.layerGroup();
		var clusterGroup = L.layerGroup();
		var visitorMGroup = L.layerGroup();
		var visitorPGroup = L.layerGroup();
		var visitorCPGroup = L.layerGroup();
		var geojson;
		var layerControl=false;
		var i = 0;
		var j = 800;
		var rocketIcon = L.MakiMarkers.icon({
			icon: null,
			color: '#FFFF00',
			size: "m"
		});
		if (layerControl === false) {  // var layerControl set to false in init phase;
			layerControl = L.control.layers(null,null,{collapsed:false}).addTo(map);
		}

		$.getJSON('/mapjson/stations', function (data) {
			var h=0;
			$.each(data, function (key, subdata) {
				stationLayers[h] = {};
				stationLayers[h].coordinates = subdata.position;
				stationLayers[h].circle=L.circle([subdata.position.lat,subdata.position.lon],subdata.radius,{
					fillColor: '#f00',
					fillOpacity: 0.3,
					stroke:false});
				stationGroup.addLayer(stationLayers[h].circle);
				h++;

			});
			addLayer(stationGroup,"Station", "Detection");
		});

		$.getJSON('/mapjson/visitors', function (data) {
			$.each(data, function (key, subdata) {
				visitorLayers[i] = {};
				visitorLayers[i].correctedPosition=subdata.correctedPosition;
				visitorLayers[i].coordinates = subdata.coordinates;
				//visitorLayers[i].setStyle({color: '#'+(Math.random()*0xFFFFFF<<0).toString(16)});
				visitorLayers[i].polyline = L.polyline([]);
				visitorLayers[i].cPolyline= L.polyline([],{color:'red'});
				visitorLayers[i].marker = L.marker([0, 0], {icon: rocketIcon});
				visitorPGroup.addLayer(visitorLayers[i].polyline)
				visitorCPGroup.addLayer(visitorLayers[i].cPolyline)
				visitorMGroup.addLayer(visitorLayers[i].marker);
				visitorLayers[i].j = 0;
				doSetTimeout(visitorLayers[i]);
				i++;
			});
			addLayer(visitorMGroup,"Marker","Besucher");
			addLayer(visitorPGroup, "syn. Trajektorie", "Besucher");
			addLayer(visitorCPGroup, "kor. Trajektorie", "Besucher");
		});

		$.getJSON('/mapjson/cluster', function (data) {
			var l=0;
			$.each(data, function (key, subdata) {
				clusterLayer[l] = {};
				clusterLayer[l].coordinates = subdata.coordinates;
				clusterLayer[l].circle = L.circle([subdata.position.lat, subdata.position.lon], subdata.distance/2, {
					fillColor: '#00f',
					fillOpacity: 0.1,
					stroke: false
				});
				clusterGroup.addLayer(clusterLayer[l].circle);
				l++;
			});
			addLayer(clusterGroup,"Cluster", "Detection");
		});

		function doSetTimeout(visitorLayer) {

			setTimeout(function () {
				var intervalFunc = setInterval(function () {
					visitorLayer = tick(visitorLayer);
					visitorLayer.j++;
					if(visitorLayer.j==Object.keys(visitorLayer.coordinates).length-1){
						map.removeLayer(visitorLayer.marker);
					}
					if (visitorLayer.j > Object.keys(visitorLayer.coordinates).length-1) {
						clearInterval(intervalFunc);
					}
				}, 10)
			}, Object.keys(visitorLayer.coordinates)[0]);
		}

		// Create a marker and add it to the map.

		function tick(visitorLayer) {
			// Set the marker to be at the same point as one
			// of the segments or the line.

			var coordinates = visitorLayer.coordinates;
			var correctedPosition=visitorLayer.correctedPosition;
			var objectKey = Object.keys(coordinates)[visitorLayer.j];
			if(correctedPosition[objectKey]!=null) {
				visitorLayer.cPolyline.addLatLng(L.latLng(
								correctedPosition[objectKey].lat,
								correctedPosition[objectKey].lon));
			}
			visitorLayer.polyline.addLatLng(L.latLng(
							coordinates[objectKey].lat,
							coordinates[objectKey].lon));
			visitorLayer.marker.setLatLng(L.latLng(
							coordinates[objectKey].lat,
							coordinates[objectKey].lon));
			return visitorLayer;
		}

		function addLayer(layer, name, group) {
			layerControl.addOverlay(layer , name, group);
		}
